package com.ejie.ab79.dao.AB63;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.AB63.Especialidades;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableRequestDto;

/**
 * EspecialidadesDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class EspecialidadesDaoImpl implements EspecialidadesDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDESPECIALIDAD", "IDTIPOESTABLECIMIENTO",
			"DESCRIPCIONCASTELLANO", "BAJA", "DESCRIPCIONEUSKERA"};

	private JdbcTemplate jdbcTemplate;

	private RowMapper<Especialidades> rwMap = new RowMapper<Especialidades>() {
		public Especialidades mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new Especialidades(resultSet.getString("IDESPECIALIDAD"),
					resultSet.getString("IDTIPOESTABLECIMIENTO"), resultSet.getString("DESCRIPCIONCASTELLANO"),
					resultSet.getInt("BAJA"), resultSet.getString("DESCRIPCIONEUSKERA"));
		}
	};

	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	@Transactional(readOnly = true)
	public List<Especialidades> findAll(Especialidades especialidades, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_ESPECIALIDAD IDESPECIALIDAD,t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, "
				+ " t1.BAJA BAJA,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA ");
		query.append("FROM ESPECIALIDADES t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(especialidades);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, EspecialidadesDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<Especialidades>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	private Map<String, ?> getWhereMap(Especialidades especialidades) {

		StringBuilder where = new StringBuilder(EspecialidadesDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (especialidades != null && especialidades.getIdEspecialidad() != null) {
			where.append(" AND t1.ID_ESPECIALIDAD = ?");
			params.add(especialidades.getIdEspecialidad());
		}
		if (especialidades != null && especialidades.getIdTipoEstablecimiento() != null) {
			where.append(" AND t1.ID_TIPO_ESTABLECIMIENTO = ?");
			params.add(especialidades.getIdTipoEstablecimiento());
		}
		if (especialidades != null && especialidades.getDescripcionCastellano() != null) {
			where.append(" AND t1.DESCRIPCION_CASTELLANO = ?");
			params.add(especialidades.getDescripcionCastellano());
		}
		if (especialidades != null && especialidades.getBaja() != null) {
			where.append(" AND t1.BAJA = ?");
			params.add(especialidades.getBaja());
		}
		if (especialidades != null && especialidades.getDescripcionEuskera() != null) {
			where.append(" AND t1.DESCRIPCION_EUSKERA = ?");
			params.add(especialidades.getDescripcionEuskera());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	public static final int STRING_BUILDER_INIT = 4096;
}
